'use strict';

Object.defineProperty(exports, "__esModule", {
   value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// Stores the path to generated graphs.
var docGraphPath = void 0;

var packageLinksAll = [];
var packageLinksDev = [];
var packageLinksMain = [];

var packageLinkMapAll = new Map();
var packageLinkMapDev = new Map();
var packageLinkMapMain = new Map();

var packageNodesAll = [];
var packageNodesDev = [];
var packageNodesMain = [];

var packageNodeMapAll = new Map();
var packageNodeMapDev = new Map();
var packageNodeMapMain = new Map();

var GraphPackageDep = function () {
   function GraphPackageDep(options) {
      _classCallCheck(this, GraphPackageDep);

      this.options = options;
   }

   _createClass(GraphPackageDep, [{
      key: 'onHandleConfig',
      value: function onHandleConfig(ev) {
         docGraphPath = '' + ev.data.config.destination + _path2.default.sep + 'graphs' + _path2.default.sep;
      }

      /**
       * The search data file must have JSPM package paths replaced with normalized versions.
       */

   }, {
      key: 'onComplete',
      value: function onComplete() {
         s_CREATE_GRAPH_JSPM_PACKAGES(this.options);
      }
   }]);

   return GraphPackageDep;
}();

exports.default = GraphPackageDep;


var s_CREATE_GRAPH_JSPM_PACKAGES = function s_CREATE_GRAPH_JSPM_PACKAGES(options) {
   var _global$$$esdoc_plugi = global['$$esdoc_plugin_jspm'];
   var jspmDevPackageMap = _global$$$esdoc_plugi.jspmDevPackageMap;
   var jspmPackageMap = _global$$$esdoc_plugi.jspmPackageMap;
   var rootPackageName = _global$$$esdoc_plugi.rootPackageName;
   var topLevelPackages = _global$$$esdoc_plugi.topLevelPackages;


   var docGraphPackagePath = docGraphPath + 'jspm_packages' + _path2.default.sep;

   // Ensure graphs directory exists.
   _fsExtra2.default.ensureDirSync(docGraphPackagePath);

   var d3Graph = _fsExtra2.default.readFileSync(_path2.default.resolve(__dirname, '../template/html/d3-graph.js'), 'utf8');
   var styleCSS = _fsExtra2.default.readFileSync(_path2.default.resolve(__dirname, '../template/html/style.css'), 'utf8');
   var indexHTML = _fsExtra2.default.readFileSync(_path2.default.resolve(__dirname, '../template/html/index.html'), 'utf8');
   var tableSorter = _fsExtra2.default.readFileSync(_path2.default.resolve(__dirname, '../template/html/jquery-tablesorter.js'), 'utf8');

   // Parse top level packages
   for (var key in topLevelPackages) {
      var value = topLevelPackages[key];
      var objectID = s_SANITIZE_CSS(value);

      var packageData = s_PARSE_PACKAGE(value, key);

      if (packageData.type !== 'npm' && packageData.type !== 'github') {
         continue;
      }

      if (typeof jspmPackageMap[key] === 'undefined' && typeof jspmDevPackageMap[key] === 'undefined') {
         throw new Error('esdoc-plugin-dependency-graphs: unknown top level package: ' + key);
      }

      var index = packageNodesAll.length;
      var object = { id: objectID, minLevel: 0, packageScope: 'all', packageData: packageData, fixed: false, index: index };

      if (!packageNodeMapAll.has(objectID)) {
         if (options.verbose) {
            console.log('esdoc-plugin-dependency-graphs: s_CREATE_GRAPH_JSPM_PACKAGES - adding top level (all) node: ' + ('' + JSON.stringify(object)));
         }
         packageNodesAll.push(object);
         packageNodeMapAll.set(objectID, object);
      }

      if (typeof jspmPackageMap[key] !== 'undefined') {
         index = packageNodesMain.length;
         object = { id: objectID, minLevel: 0, packageScope: 'main', packageData: packageData, fixed: false, index: index };

         if (!packageNodeMapMain.has(objectID)) {
            if (options.verbose) {
               console.log('esdoc-plugin-dependency-graphs: s_CREATE_GRAPH_JSPM_PACKAGES - adding top level (dev) node: ' + ('' + JSON.stringify(object)));
            }

            packageNodesMain.push(object);
            packageNodeMapMain.set(objectID, object);
         }
      }

      if (typeof jspmDevPackageMap[key] !== 'undefined') {
         index = packageNodesDev.length;
         object = { id: objectID, minLevel: 0, packageScope: 'dev', packageData: packageData, fixed: false, index: index };

         if (!packageNodeMapDev.has(objectID)) {
            if (options.verbose) {
               console.log('esdoc-plugin-dependency-graphs: s_CREATE_GRAPH_JSPM_PACKAGES - adding top level (main) node: ' + ('' + JSON.stringify(object)));
            }

            packageNodesDev.push(object);
            packageNodeMapDev.set(objectID, object);
         }
      }
   }

   if (options.verbose) {
      console.log('esdoc-plugin-dependency-graphs: s_CREATE_GRAPH_JSPM_PACKAGES --- parsing top level all dependencies');
   }

   // Recursively parse all dependencies
   s_DEPTH_TRAVERSAL_NODES(_underscore2.default.clone(packageNodesAll), packageNodesAll, packageNodeMapAll, packageLinksAll, packageLinkMapAll, 'all', 1, options);

   if (options.verbose) {
      console.log('esdoc-plugin-dependency-graphs: s_CREATE_GRAPH_JSPM_PACKAGES --- parsing top level dev dependencies');
   }

   // Recursively parse dev dependencies
   s_DEPTH_TRAVERSAL_NODES(_underscore2.default.clone(packageNodesDev), packageNodesDev, packageNodeMapDev, packageLinksDev, packageLinkMapDev, 'dev', 1, options);

   if (options.verbose) {
      console.log('esdoc-plugin-dependency-graphs: s_CREATE_GRAPH_JSPM_PACKAGES --- parsing top level main dependencies');
   }

   // Recursively parse main dependencies
   s_DEPTH_TRAVERSAL_NODES(_underscore2.default.clone(packageNodesMain), packageNodesMain, packageNodeMapMain, packageLinksMain, packageLinkMapMain, 'main', 1, options);

   // Determine max package level for `all` category.
   var maxPackageLevel = 0;
   packageNodesAll.forEach(function (node) {
      if (node.minLevel > maxPackageLevel) {
         maxPackageLevel = node.minLevel;
      }
   });
   packageLinksAll.forEach(function (link) {
      if (link.minLevel > maxPackageLevel) {
         maxPackageLevel = link.minLevel;
      }
   });

   var graphPackageDataAll = {
      maxLevel: maxPackageLevel,
      directed: true,
      multigraph: false,
      graph: [],
      nodes: packageNodesAll,
      links: packageLinksAll
   };

   // Determine max package level for `dev` category.
   maxPackageLevel = 0;
   packageNodesDev.forEach(function (node) {
      if (node.minLevel > maxPackageLevel) {
         maxPackageLevel = node.minLevel;
      }
   });
   packageLinksDev.forEach(function (link) {
      if (link.minLevel > maxPackageLevel) {
         maxPackageLevel = link.minLevel;
      }
   });

   var graphPackageDataDev = {
      maxLevel: maxPackageLevel,
      directed: true,
      multigraph: false,
      graph: [],
      nodes: packageNodesDev,
      links: packageLinksDev
   };

   // Determine max package level for `main` category.
   maxPackageLevel = 0;
   packageNodesMain.forEach(function (node) {
      if (node.minLevel > maxPackageLevel) {
         maxPackageLevel = node.minLevel;
      }
   });
   packageLinksMain.forEach(function (link) {
      if (link.minLevel > maxPackageLevel) {
         maxPackageLevel = link.minLevel;
      }
   });

   var graphPackageDataMain = {
      maxLevel: maxPackageLevel,
      directed: true,
      multigraph: false,
      graph: [],
      nodes: packageNodesMain,
      links: packageLinksMain
   };

   var data = {
      css: styleCSS,
      packageDataAll: JSON.stringify(graphPackageDataAll),
      packageDataDev: JSON.stringify(graphPackageDataDev),
      packageDataMain: JSON.stringify(graphPackageDataMain),
      js: tableSorter,
      js2: d3Graph,
      maxPackageLevel: graphPackageDataAll.maxLevel,
      title: rootPackageName
   };

   _fsExtra2.default.writeFileSync(docGraphPackagePath + 'index.html', _underscore2.default.template(indexHTML)(data));
};

// Provides a recursive function traversing package dependencies.
var s_DEPTH_TRAVERSAL_NODES = function s_DEPTH_TRAVERSAL_NODES(packageDeps, packageNodes, packageNodeMap, packageLinks, packageLinkMap, packageScope, depth, options) {
   var childPackageMap = global['$$esdoc_plugin_jspm'].childPackageMap;


   var nextLevelPackages = [];

   for (var cntr = 0; cntr < packageDeps.length; cntr++) {
      var packageDep = packageDeps[cntr];

      if (options.verbose) {
         console.log('esdoc-plugin-dependency-graphs: s_DEPTH_TRAVERSAL_NODES - depth: ' + depth + '; packageDep.index: ' + (packageDep.index + '; dep: ' + JSON.stringify(packageDep)));
      }

      var childDepMap = childPackageMap[packageDep.packageData.fullPackage];

      if (typeof childDepMap === 'undefined') {
         continue;
      }

      // Parse top level packages
      for (var key in childDepMap) {
         var value = childDepMap[key];

         var packageData = s_PARSE_PACKAGE(value, key);

         if (packageData.type !== 'npm' && packageData.type !== 'github') {
            continue;
         }

         var index = packageNodes.length;
         var objectID = s_SANITIZE_CSS(value);

         var newNode = { id: objectID, minLevel: depth, packageScope: packageScope, packageData: packageData, fixed: false, index: index };

         if (!packageNodeMap.has(objectID)) {
            nextLevelPackages.push(newNode);

            if (options.verbose) {
               console.log('esdoc-plugin-dependency-graphs: s_DEPTH_TRAVERSAL_NODES - depth: \' + depth + \'; adding node: ' + ('' + JSON.stringify(newNode)));
            }

            packageNodes.push(newNode);
            packageNodeMap.set(objectID, newNode);

            packageLinks.push({ source: packageDep.index, target: index, minLevel: depth });
         } else {
            // Update min level if current depth is greater than stored depth
            var existingNode = packageNodeMap.get(objectID);

            if (existingNode && newNode.minLevel < existingNode.minLevel) {
               existingNode.minLevel = newNode.minLevel;

               if (options.verbose) {
                  console.log('esdoc-plugin-dependency-graphs: s_DEPTH_TRAVERSAL_NODES - depth: ' + depth + '; updating min level: ' + ('' + JSON.stringify(existingNode)));
               }
            }

            packageLinks.push({ source: packageDep.index, target: existingNode.index, minLevel: depth });
         }
      }
   }

   if (nextLevelPackages.length > 0) {
      if (options.verbose) {
         console.log('esdoc-plugin-dependency-graphs: s_DEPTH_TRAVERSAL_NODES - depth: ' + depth + '; nextLevelPackages: ' + ('' + JSON.stringify(nextLevelPackages)));
      }

      s_DEPTH_TRAVERSAL_NODES(nextLevelPackages, packageNodes, packageNodeMap, packageLinks, packageLinkMap, packageScope, depth + 1, options);
   }
};

var s_PARSE_PACKAGE = function s_PARSE_PACKAGE(value, key) {
   var values = value.split(/(.*):(.*)@(.*)/);

   var result = {
      type: values[1],
      name: values[2],
      fullName: values[2],
      fullPackage: value,
      version: values[3],
      isAliased: false
   };

   switch (result.type) {
      case 'github':
         result.link = 'https://github.com/' + result.name;

         values = result.name.split(/(.*)\/(.*)/);

         result.owner = values[1];
         result.name = values[2];
         result.fullName = values[2];
         break;

      case 'npm':
         result.link = 'https://www.npmjs.com/package/' + result.name;
         break;

      default:
         throw new Error('s_PARSE_PACKAGE error, unknown package: ' + value);
   }

   if (typeof key === 'string' && result.name !== key) {
      result.name = key;
      result.isAliased = true;
   }

   return result;
};

/**
 * Replaces semver and other special characters with `-`.
 *
 * @param {string}   value - Value to sanitize.
 * @returns {string}
 */
var s_SANITIZE_CSS = function s_SANITIZE_CSS(value) {
   return value.replace(/(\.|\/|:|@|\^|>=|>|<=|<|~|\*)/gi, '-');
};